package hibernate;

import org.hibernate.Session;  
import org.hibernate.SessionFactory;  
import org.hibernate.cfg.Configuration;  
import org.hibernate.service.ServiceRegistry;  
import org.hibernate.service.ServiceRegistryBuilder;  
import org.hibernate.*;

import java.io.*;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.*;

public class HibernateMain {  
  
 public static void main(String[] args) throws IOException {  
      
  Configuration configuration=new Configuration();  
  configuration.configure();  
  ServiceRegistry sr= new ServiceRegistryBuilder().applySettings(configuration.getProperties()).buildServiceRegistry();  
  SessionFactory sf=configuration.buildSessionFactory(sr);
  java.util.Date date= new java.util.Date();

  Emp emp1=new Emp();  
  emp1.setEmpNo(1);
  emp1.setEname("Ename1");
  emp1.setHireDate(new Timestamp(date.getTime()));
  emp1.setSal(1000.10);
  
  Emp emp2=new Emp();  
  emp2.setEmpNo(2);
  emp2.setEname("Ename2");
  emp2.setHireDate(new Timestamp(date.getTime()));
  emp2.setSal(2000.34);
    
  Emp emp3=new Emp();  
  emp3.setEmpNo(3);
  emp3.setEname("Ename3");
  emp3.setHireDate(new Timestamp(date.getTime()));
  emp3.setSal(3000.81);
  
  
  Session ss=sf.openSession();  
  ss.beginTransaction();
  ss.save(emp1);
  ss.save(emp2);
  ss.save(emp3);
  ss.getTransaction().commit();
  BufferedReader br=null;
  String line;
  String hql;
  Query query ;
	
  try {// file input1 contains basic sql queries
	br = new BufferedReader(new FileReader("input1.sql"));
	PrintWriter writer = new PrintWriter("output1.txt", "UTF-8");
	while ((line = br.readLine()) != null) {
		if (line.startsWith("#"))
			continue;
	  hql = line;
	  query = ss.createQuery(hql);
	  //query.setMaxResults(2); //this is equal to top
	  writer.println();
	  writer.append(line+ "\n");
	 for(Iterator it=query.iterate();it.hasNext();)  
	  {  
	   Emp emp = (Emp)it.next();  
	     
	    System.out.println(emp.getEmpNo()+ ", " + emp.getEname() + ", " + emp.getHireDate() + ", " + emp.getSal());
		writer.append(emp.getEmpNo()+ ", " + emp.getEname() + ", " + emp.getHireDate() + ", " + emp.getSal() + "\n");
		  
	  }
	  writer.println();
	}
	  writer.close();
	 
	  //file input2 contains sql functions registed in dialect
	  br = new BufferedReader(new FileReader("input2.sql"));
	  writer = new PrintWriter("output2.txt", "UTF-8");
		while ((line = br.readLine()) != null) {
			if (line.startsWith("#"))
				continue;
		  hql = line;
		  query = ss.createQuery(hql);
		  writer.println();
		  writer.append(line+ "\n");
	  List<Object[]> results = (List<Object[]>)query.list();
	  for(Object[] data: results){
		  Object intdata = data[0];
		  Object stringData = data[1];
		  Object ts = data[2];
		  Object dblData = data[3];
	       System.out.println(intdata+ ", " + stringData + ", " + ts + ", " + dblData);
	       writer.append(intdata+ ", " + stringData + ", " + ts + ", " + dblData + "\n");
	  }
	  writer.println();
		}
		 writer.close();
	
	  ss.close();
	 
}
	  catch (FileNotFoundException e) {
	// TODO Auto-generated catch block
	e.printStackTrace();
	  }
    finally
    {
  br.close();
    }

  
 }  
}

