package org.hibernate.dialect;

import org.hibernate.dialect.function.*;
import org.hibernate.type.StandardBasicTypes;


public class openAccessDialect
  extends Dialect
  
{
  public openAccessDialect()
  {
    registerColumnType(-7, "bit");
    registerColumnType(-5, "bigint");
    registerColumnType(5, "smallint");
    registerColumnType(-6, "tinyint");
    registerColumnType(4, "integer");
    registerColumnType(1, "character(1)");
    registerColumnType(12, "varchar($l)");
    registerColumnType(6, "float");
    registerColumnType(7, "real"); 
    registerColumnType(8, "double");
    registerColumnType(91, "date");
    registerColumnType(92, "time");
    registerColumnType(93, "timestamp");
    registerColumnType(-3, "varbinary($l)");
    registerColumnType(2, "numeric($p,$s)");
    
    registerFunction("curtimestamp", new NoArgSQLFunction("curtimestamp", StandardBasicTypes.TIMESTAMP, false));
    registerFunction("curdate", new NoArgSQLFunction("curdate", StandardBasicTypes.DATE, false));
    registerFunction("curtime", new NoArgSQLFunction("curtime", StandardBasicTypes.TIME, false));
    registerFunction("dateadd", new StandardSQLFunction("dateadd", StandardBasicTypes.TIMESTAMP));
    registerFunction("datediff", new StandardSQLFunction("datediff", StandardBasicTypes.INTEGER));
    registerFunction("dayname", new StandardSQLFunction("dayname", StandardBasicTypes.STRING));
    registerFunction("dayofweek", new StandardSQLFunction("dayofweek", StandardBasicTypes.INTEGER));
    registerFunction("dayofmonth", new StandardSQLFunction("dayofmonth", StandardBasicTypes.INTEGER));
    registerFunction("dayofyear", new StandardSQLFunction("dayofyear", StandardBasicTypes.INTEGER));
    registerFunction("hour", new StandardSQLFunction("hour", StandardBasicTypes.INTEGER));
    registerFunction("minute", new StandardSQLFunction("minute", StandardBasicTypes.INTEGER));
    registerFunction("month", new StandardSQLFunction("month", StandardBasicTypes.INTEGER));
    registerFunction("monthname", new StandardSQLFunction("monthname", StandardBasicTypes.STRING));
    registerFunction("now", new StandardSQLFunction("now", StandardBasicTypes.TIMESTAMP));
    
    // system functions
    registerFunction("database", new NoArgSQLFunction("database", StandardBasicTypes.STRING));
    registerFunction("user", new NoArgSQLFunction("user", StandardBasicTypes.STRING));
    
    //numeric functions
    registerFunction("radians", new StandardSQLFunction("radians", StandardBasicTypes.DOUBLE));
    registerFunction("degrees", new StandardSQLFunction("degrees", StandardBasicTypes.DOUBLE));
    registerFunction("ceiling", new StandardSQLFunction("ceiling", StandardBasicTypes.INTEGER));
    registerFunction("floor", new StandardSQLFunction("floor", StandardBasicTypes.INTEGER));
    
    //cast and convert
    registerFunction("cast", new CastFunction());
    registerFunction("convert", new ConvertFunction());
    
    //string functions
    registerFunction("replace", new StandardSQLFunction("replace", StandardBasicTypes.STRING));
    registerFunction("repeat", new StandardSQLFunction("repeat", StandardBasicTypes.STRING));
    
    registerKeyword("top");
    
    
  }
  
  
  public String getCurrentTimestampSelectString()
  {
    return "select now()";
  }
  

  
}
